system.require('std/core/bind.em');
system.require('std/core/repeatingTimer.em');


if (typeof(bank) === 'undefined')
	bank = {};

bank = system.Class.extend({
    //Init sets up the various data structures and the interaction message handlers.
    init: function() {
		system.self.mesh = 'meerkat:///kchung25/sirikatatower.dae/optimized/2/sirikatatower.dae';
        system.print('Init bank');
        this.userPwordMap = {};
		this.presUserMap = {};
		this.userPresMap = {};
        this.acctBalanceMap = {};
		this.presOwnMap = {};
		this.tradeRecords = {};
        this.connected = false;
        this.key = 'key';
        this.connectedBanks = [];
		this.tradeHandlers = [];
        this.loginHandlers = [];
		this.userPings={};
		this.storedTrades = {};
		this.tradesOpen= {};
		
		
        std.core.bind(this.loginRequest, this) << {'action':'login':};
        std.core.bind(this.createRequest, this) << {'action':'create':};
        std.core.bind(this.getRequest, this) << {'action':'get':};
        std.core.bind(this.giveRequest, this) << {'action':'give':};
        std.core.bind(this.tradeRequest, this) << {'action':'trade':};
		std.core.bind(this.clientRequest, this) << {'action':'touch':};
		std.core.bind(this.registerRequest, this) << {'action':'registerObject':};
		std.core.bind(this.checkUser, this) << {'action':'checkUser':};
		std.core.bind(this.logout, this) << {'action':'logout':};
		std.core.bind(this.updateUserPing, this) << {'action':'updatePing':};
		std.core.bind(this.identityResponse, this) << {'areYou':'Bank':};
		
		new std.core.RepeatingTimer(10, std.core.bind(this.checkUsers, this));
		// std.core.bind(this.connectBank, this) << {'request':'bankConnect':};
	},
	identityResponse: function(msg, sender) {
		{yes:'Bank'}>>sender>>[];
	},
	/*This is called when a client interacts through an action:touch message to the bank.  It
	sends over the script necessary to interact with the bank. */
	checkUsers: function() {
		for (user in this.userPings) {
			if (this.userPings[user] === false) {
				system.__debugPrint('\n\n\n\n******************LOGGING OUT INACTIVE USER********************\n\n\n\n\n');
				var sender = this.userPresMap[user];
				delete this.presUserMap[sender];
				delete this.userPresMap[user];
				delete this.userPings[user];
			} else {
				this.userPings[user] = false;
			}
		}
	},
	
	updateUserPing: function (msg, sender) {
		if (sender.toString() in this.presUserMap) {
			system.__debugPrint('got ping');
			var user = this.presUserMap[sender.toString()];
			this.userPings[user] = true;
		}
	},
    clientRequest: function (msg, client) {
	system.print('GOT MESSAGE');
	
	/*handleClient is the first function sent to the client.  It sets up a message handler which
	responds when the entire state.Connection class is sent over. */
	
	  function handleClient () {
	    var bankConnHandler;
	    function connHandler (msg, sender) {
		      system.__debugPrint('Got bank connection client.');
  			  bankConnection = new msg.state(sender);     /*Instantiates a new state.Connection.*/
			  system.__debugPrint('Created new bankConnection.');
			  var confirm = new Object();
			  confirm.confirm = 'success';    /*Sends a success reply back to the bank. */
			  if (typeof(bankConnCB) !=='undefined') bankConnCB();
			  msg.makeReply(confirm) >> [];
			  bankConnHandler.clear();
		}
        //Sets up a handler waiting for the state.Connection message.
		bankConnHandler = std.core.bind(connHandler, this) << {'script':'client':};
		
		system.print('Set up connection handler.');
		var stateMsg = new Object();
		stateMsg.request = 'stateConnection';
		system.__debugPrint('Setting up connHandler on clientside');
		
		//Sends a message to the bank saying it is now ready for state.Connection to be sent.
		stateMsg >> system.createVisible(bankStr) >> [];
	  }
	  
	  //A few lines appended around handleClient.  
	  var bankStr = 'var bankStr ="' + system.self.toString() + '"; \n';
	  var line = 'var bankConnection; \n';
	  
	  //This line is necessary to actually call handleClient on the client side.
	  var handleString = bankStr + line + handleClient.toString() + "\n handleClient();";
	  
	  
	  var request = {
            request : 'script',
            script : handleString
        };

			
	  
	  system.print('Sending handler to client.');
	  system.require('std/state.em');
	  system.print('Sending state class to client.');
	  var stateMsg = {script: 'client', state: state.Connection};
	  var index = this.loginHandlers.length;
	  this.loginHandlers.push(std.core.bind(this.sendState,this,stateMsg, client, index)<< {'request':'stateConnection':}<< client);
	  system.__debugPrint('\n\nSending connhandler to client:' + client.toString() + '\n\n');
	  request >> client >> [];
	  
	  system.print('Sent state class to client.');
	  
	},
	/*sendState actually sends over the state.Connection to the client, it also sets a 2 second timeout,
	if the client does not respond within 2 seconds of it being sent then it is sent again until they
	finally do respond. */
	sendState: function(stateMsg,client, index, msg,sender) {
	  system.__debugPrint('\n\nSending state to:' + client.toString() + '\n\n');
	  system.print('test');
	  stateMsg >> client >> [function() {}, 2, std.core.bind(this.resendState,this,stateMsg,client)];
	  //stateMsg >> client >> [];
	  this.loginHandlers[index].clear();
	},
	
	//This just keeps resending the state.Connection if the client doesn't respond.
	resendState: function(msg, client) {
	  msg >> client >> [function() {}, 2, std.core.bind(this.resendState,this,msg,client)];
	},
	
	/*Handles a login request from an existing account.*/
	loginRequest: function (msg, sender) {
        system.print('Received login request.');
        var newMsg = {};
		var openTrades = false;
        if (msg.username in this.userPwordMap ) {
			if (!(sender.toString() in this.presUserMap)) {
				if (!((msg.username in this.userPresMap) && this.userPresMap[msg.username] !== sender.toString())) {
					if (this.userPwordMap[msg.username].password == msg.password) {
						newMsg.print = 'Successfully logged in.';
						//this.userPwordMap[msg.username].presence = sender.toString();
						this.presUserMap[sender.toString()] = msg.username;
						this.userPresMap[msg.username] = sender.toString();
						this.userPings[msg.username] = true;
						this.tradesOpen[msg.username] = false;
						if(!(sender.toString()) in this.presOwnMap)
							this.presOwnMap[sender.toString()] = msg.username;
						if (msg.username in this.storedTrades) {
							openTrades = true;
							//this.openStoredTrades(msg.username,sender.toString());
						}
					} else {
						newMsg.error = 'Incorrect password.';
					}
				} else {
					newMsg.error = 'Another user is already logged into this account.';
				}
			} else {
				newMsg.error = 'Already logged in.';
			}
        } else {
            newMsg.print = 'I do not recognize this username.  Try creating a new account.';
            newMsg.error = 'Unrecognized username.';
            //this.createRequest(msg, sender);
        }
		if (openTrades) {
			system.__debugPrint('Setting up old trade handler');
			var index = this.tradeHandlers.length;
			var handler = std.core.bind(this.openTrades, this, msg.username, index) << {'action':'getTrades':} << sender;
			this.tradeHandlers.push(handler);
		}
		msg.makeReply(newMsg) >> [];
		
		
	},
	
	
    /*createRequest handles account creation from a new account.*/
	createRequest: function (msg, sender) {
		system.__debugPrint('create request');
        system.print('Received create request.');
        var newMsg = {};
        if (msg.username in this.userPwordMap) {
            newMsg.error = 'Username already exists.';
        } else if (!(sender.toString() in this.presUserMap)){
            var account = {};
            account.password = msg.password;
            
			
            this.userPwordMap[msg.username] = account;
			//this.userPwordMap[msg.username].presence = sender.toString();
			this.presUserMap[sender.toString()] = msg.username;
			this.userPresMap[msg.username] = sender.toString();
			this.userPings[msg.username] = true;
			this.tradesOpen[msg.username] = false;
			system.print(msg.username);
			system.prettyprint(this.userPwordMap);
			system.prettyprint(this.presUserMap);
			if(!(sender.toString()) in this.presOwnMap)
				this.presOwnMap[sender.toString()] = msg.username;
            this.acctBalanceMap[msg.username] = 100;
			this.tradeRecords[msg.username] = {};
            newMsg.print = 'Successfully created account.';
            if (msg.username in this.userPwordMap)
                system.print('Really successfully created account.');
        } else {
			newMsg.error = 'Already logged in.';
		}
        msg.makeReply(newMsg) >> [];
	},
	logout: function(msg, sender) {
		system.__debugPrint('LOGGING OUT');
		var resp = new Object();
		if (!(sender.toString() in this.presUserMap))
			resp.error = 'Not logged in.';
		else {
			var username = this.presUserMap[sender.toString()];
			delete this.presUserMap[sender.toString()];
			delete this.userPresMap[username];
			delete this.userPings[username];
			delete this.tradesOpen[username];
			resp.success = 'Successfully logged out.';
		}
		msg.makeReply(resp) >> [];
	},
	checkUser: function(msg, requester) {
		var resp = new Object();
		if (msg.pres in this.presUserMap && msg.username === this.presUserMap[msg.pres]) {
			resp.success = true;
		} else 
			resp.failure = true;
		msg.makeReply(resp) >> [];
	},
	/*Registers a presence as owned by a given user.  No GUI is provided by state.em
	yet for this functionality. */
	registerRequest: function (msg, sender) {
	    var resp = new Object();
	    if (!(sender.toString() in this.presUserMap))
			resp.error = 'Not logged in.';
		if (!(msg.object in this.presOwnMap)) {
		    this.presOwnMap[msg.object] = this.presUserMap[sender.toString()];
			resp.object = msg.object;
		}
		msg.makeReply(resp) >> [];
	},
	
	/*Checks the possibility of an entire multi object for multi object transaction. */
	checkTransaction: function(sender, what, trader2, inExchangeFor) {
		if (!(sender.toString() in this.presUserMap))
			return 'Not logged in.';
		var trader1 = this.presUserMap[sender.toString()];
		if (!(trader2 in this.userPwordMap))
			return 'Unknown recipient username "' + trader2 + '".';
		
	
	    for (var i=0; i< what.length; i++) {
		  var result = this.checkValidity(trader1,what[i],trader2);
		  if (typeof(result)==='string') {
			return result;
		  }
	    }
		if (typeof(inExchangeFor) == 'undefined') return true;  /*If it is just a give request then it is valid.*/
		
		for (var j=0; j<inExchangeFor.length; j++) {
		  var result = this.checkValidity(trader2,inExchangeFor[j],trader1);
		  if (typeof(result)==='string') {
			return result;
		  }
	    }
		return true;
	},
	
	give: function(what, from, to) {
	system.__debugPrint('\nGiving:' + what.value);
	system.__debugPrint('\nGiving:\n' + this.acctBalanceMap);
	    system.__debugPrint('\nTransferring.');
		if(what.type == 'money') {
			system.__debugPrint('\nGiving (parsed):' + parseInt(what.value));
		    system.__debugPrint('Acct Bal From Before:' + this.acctBalanceMap[from]);
			this.acctBalanceMap[from] = this.acctBalanceMap[to]-parseInt(what.value);
			 system.__debugPrint('\nAcct Bal From After:' + this.acctBalanceMap[from]);
			 system.__debugPrint('\nAcct BalTo Before:' + this.acctBalanceMap[to]);
			this.acctBalanceMap[to] = this.acctBalanceMap[to]+parseInt(what.value);
			system.__debugPrint('\nAcct BalTo After:' + this.acctBalanceMap[to]);
			return from + ' successfully gave $' + what.value +
					' to ' + to + '.';
		} else if(what.type == 'presence') {
			this.presOwnMap[what.value] = to;
			return from + ' successfully gave ' + what.value + ' to ' +
					to + '.';
		} else if (what.type == 'string') {
			return from + ' successfully gave the service string ' + what.value + ' to ' + to + '.';
		
		} else {
			throw('Unrecognized property type: "' + what.type + '".');
		}
		
	},
	
	/*Checks the validity of a single request.  For a multi object/money trade
	this checks the validity of each individual item in the trade. */
    checkValidity: function(sender,what, recipient) {
	  
		if (what.type == 'money' && what.value >
				this.acctBalanceMap[sender]) {
			return 'You do not have $' + what.value +
					' in your account.';
		} else if(what.type == 'presence')
		    {
                if (what.value in this.presOwnMap)
				    {  
						if (this.presOwnMap[what.value] != sender) {
							return what.value + ' belongs to ' + this.presOwnMap[what.value] +
							'.';
						}
				}
			}
		return true;
	},
	
	/*Handles a request to give something without need for approval or checks on the recipient side. */
	giveRequest: function (msg, sender) {
        system.print('Received give request.');
        var replyMsg = {};
		var status = this.checkTransaction(sender, msg.what, msg.to);
		if (typeof(status) === 'string') {		
            replyMsg.error = status;
			replyMsg.result = 'failed, need more neo shekels or something';
			msg.makeReply(replyMsg) >> [];
			return;
		}
		
		try {
		    replyMsg.print = '';
			for (var i = 0; i < msg.what.length; i++) {
			   replyMsg.print += this.give(msg.what[i], this.presUserMap[sender.toString()], tmsg.to);
			}
			replyMsg.result = 'approved';
			
		} catch(e) {
			replyMsg.error = e;
			replyMsg.result = 'failed';
		}
		
		msg.makeReply(replyMsg) >> [];
	},
	
	
	/*The Big Kahuna.  Handles trade requests. */
	tradeRequest: function(msg, sender) {
        system.print('Received trade request.');
        var replyMsg = {};
		
		/*Saves the seqNo and streamID of the original message.  These are used later
		for identification of multiple responses to the same original message.*/
		replyMsg.seqNoID = msg.seqNo;
		replyMsg.id = msg.streamID;
		
		
		/*Checks validity of the transaction here.*/
		var status = this.checkTransaction(sender, msg.what, msg.to, msg.forTrade);
		if (typeof(status) === 'string') {
            replyMsg.error = status;
			replyMsg.status = 'failure, need more neo shekels or something';
			msg.makeReply(replyMsg) >> [];
			return;
		}
		
		
		
		var selfid = system.self.toString();
		var recOnline = false;
		if (msg.to in this.userPresMap) {
			recOnline = true;
		}
		//var line = 'var bank ="' + selfid + '"; \n';
			
		/*Here we construct the big string describing the trade.  I think it is all grammatically correct.  
		Also saves it as a record string that will be recorded if the trade is successful. */
		var valStr= '';
		for (var i =0; i<msg.what.length; i++) {
			if (i>0 && msg.what.length > 2 && i<(msg.what.length-1))
			 valStr+=', ';
			if (i==(msg.what.length-1) && i>0)
			 valStr+=' and ';
			var addStr;
			if (msg.what[i].type === 'money') { 
				addStr = (msg.what[i].value.toString()+' neo shekels');
			} else if (msg.what[i].type === 'presence') {
				addStr = ('the presence: '+msg.what[i].value.toString());
			} else if (msg.what[i].type === 'string') {
				addStr = msg.what[i].value;
			}
			valStr+= addStr;
		}		
		var forStr = '';
		for (var i =0; i<msg.forTrade.length; i++) {
			if (i>0 && msg.forTrade.length > 2 && i<(msg.what.length-1) )
			  forStr+=', ';
			if (i==(msg.forTrade.length-1) && i>0)
			 forStr+=' and ';
			var addStr;
			if (msg.forTrade[i].type === 'money') { 
				addStr = (msg.forTrade[i].value.toString()+' neo shekels');
			} else if (msg.forTrade[i].type === 'presence') {
				addStr = ('the presence: '+msg.forTrade[i].value.toString());
			} else if (msg.forTrade[i].type === 'string') {
				addStr = msg.forTrade[i].value;
			}
			forStr+= addStr;
			
		}					
		var tradeStr ='Do you want to trade ' + forStr + ' for ' + valStr + ' from '+this.presUserMap[sender.toString()] + '?\n';
		var recordStr = msg.to + ' traded ' + forStr + ' for ' + valStr + ' from ' + this.presUserMap[sender.toString()] + '.';
		
		if (!msg.asynch && recOnline && !this.tradesOpen[msg.to]) {
			
			
			var tradeMsg = new Object();
			tradeMsg.tradeRequest = tradeStr;
			
			
			/*This is the handler if the other party in the trade accepts the trade.  Here the items are actually
            exchanged, confirmation messages (or error) are sent, records of the trade are made for both users
            and the trade handler is canceled.  Trade done.			*/
			var acceptTrade = function(tmsg, tsender, handler, recordString, msg, sender) {
				var tvis = system.createVisible(tsender);
				var tuser = this.presUserMap[tsender.toString()];
				confirmMsg = {status: 'success', seqNoID: tmsg.seqNo,
						id: tmsg.streamID};
				
				try {
				    confirmMsg.print = '';
					for (var i = 0; i < tmsg.what.length; i++) {
					  confirmMsg.print += this.give(tmsg.what[i], tuser, tmsg.to);
					}
					confirmMsg.print += '\n';
					for (var i = 0; i < tmsg.forTrade.length; i++) {
					  confirmMsg.print += this.give(tmsg.forTrade[i], tmsg.to, tuser);
					}
					
				} catch(e) {
					confirmMsg.status = 'failure';
					confirmMsg.error = e;
				}
				
				//Sends a confirmation message. Need to change to include confirmation message for other party.
				confirmMsg >> tvis >> [];
				
				
				//Creating a record of the trade for both parties.
				var record = new Object();
				record.trade = recordString;
				this.tradeRecords[tuser][tmsg.to] = record;
				this.tradeRecords[tmsg.to][tuser] = record;
				
				this.tradesOpen[tmsg.to] = false;
				
				//Cancelling the trade accept/decline handlers.
				
				this.tradeHandlers[handler+1].clear();
				this.tradeHandlers[handler].clear();
				this.openTrades(tmsg.to,-1,{},tsender);
			};
			
			/*Handles the event where the trade is declined.  Basically just clears the trade response
			handlers and sends back a trade failure message to the initiator. */
			var declineTrade = function(trader, origMsg, handler, msg, sender) {
				var resp = new Object();
				resp.status = 'failure';
				resp.result = "failed, they didn't like it!!!!!!!";
				resp.seqNoID = origMsg.seqNo;
				resp.id = origMsg.streamID;
				resp >> trader >> [];
				
				this.tradesOpen[origMsg.to] = false;
				
				this.tradeHandlers[handler].clear();
				this.tradeHandlers[handler+1].clear();
				this.openTrades(tmsg.to,-1,{},tsender);
			};

			var user = this.presUserMap[sender.toString()];
			var targetVis = system.createVisible(this.userPresMap[msg.to]);
			
			//Grabbing the index and storing the handler so the handler can cancel itself when finished.
			var index = this.tradeHandlers.length;
			var tradeHandler = std.core.bind(acceptTrade, this, msg, sender.toString(), index, recordStr) << {'resp':'accept':} << targetVis;
			this.tradeHandlers.push(tradeHandler);
		    
			
			//Setting up decline handler.
			var decHandler = std.core.bind(declineTrade, this, sender.toString(), msg, index) << {'resp':'decline':} << targetVis;
			//request >> targetVis >> [];
			this.tradeHandlers.push(decHandler);
			//Sending out messages to both parties.
			tradeMsg >> targetVis >> [];
			this.tradesOpen[msg.to] = true;
			
		} else if (!recOnline || msg.asynch || this.tradesOpen[msg.to]) {
			this.storeTrade(msg.to, msg, sender.toString(), tradeStr);
			replyMsg.asynch = 'stored for when ' + msg.to+' logs in or closes trade window.';
		
		} 
		msg.makeReply(replyMsg) >> [];
		
	},
	storeTrade: function(recip, msg, sender, trade) {
		if (recip in this.storedTrades) {
			system.__debugPrint('Adding trade for user that already has entry.');
			this.storedTrades[recip].push({tradeMsg : msg, trader: sender, tradeStr: trade});
		} else {
			system.__debugPrint('Adding new trade entry for user');
			this.storedTrades[recip] = [];
			this.storedTrades[recip].push({tradeMsg : msg, trader: sender, tradeStr: trade});
		}
	},
	openStoredTrades: function(username, pres) {
		var acceptTradeDelayed = function(tmsg, tsender, handler, recordString, recPres, msg, sender) {
			var tvis = system.createVisible(tsender);
			var tuser = this.presUserMap[tsender.toString()];
			confirmMsg = {status: 'success', seqNoID: tmsg.seqNo,
					id: tmsg.streamID};
			
			try {
				confirmMsg.print = '';
				for (var i = 0; i < tmsg.what.length; i++) {
				  confirmMsg.print += this.give(tmsg.what[i], tuser, tmsg.to);
				}
				confirmMsg.print += '\n';
				for (var i = 0; i < tmsg.forTrade.length; i++) {
				  confirmMsg.print += this.give(tmsg.forTrade[i], tmsg.to, tuser);
				}
				
			} catch(e) {
				confirmMsg.status = 'failure';
				confirmMsg.error = e;
			}
			
			//Sends a confirmation message. Need to change to include confirmation message for other party.
			confirmMsg >> tvis >> [];
			
			
			//Creating a record of the trade for both parties.
			var record = new Object();
			record.trade = recordString;
			this.tradeRecords[tuser][tmsg.to] = record;
			this.tradeRecords[tmsg.to][tuser] = record;
			
			this.storedTrades[tmsg.to].splice(0,1);
			this.tradesOpen[tmsg.to] = false;
			this.openStoredTrades(tmsg.to,recPres);
			
			//Cancelling the trade accept/decline handlers.
			this.tradeHandlers[handler+1].clear();
			this.tradeHandlers[handler].clear();
		};
		
		/*Handles the event where the trade is declined.  Basically just clears the trade response
		handlers and sends back a trade failure message to the initiator. */
		var declineTradeDelayed = function(trader, origMsg, handler, recPres, msg, sender) {
			var resp = new Object();
			resp.status = 'failure';
			resp.result = "failed, they didn't like it!!!!!!!";
			resp.seqNoID = origMsg.seqNo;
			resp.id = origMsg.streamID;
			resp >> trader >> [];
			
			this.storedTrades[origMsg.to].splice(0,1);
			this.tradesOpen[origMsg.to] = false;
			this.openStoredTrades(origMsg.to,recPres);
			this.tradeHandlers[handler].clear();
			this.tradeHandlers[handler+1].clear();
		};
		var recOnline = false;
		if (username in this.userPresMap) {
			recOnline = true;
		}
		system.__debugPrint('In trade sender\n');
		if (this.storedTrades[username].length > 0 && recOnline && this.tradesOpen[username] === false) {
			
		
			var msg = this.storedTrades[username][0].tradeMsg;
			var sender = this.storedTrades[username][0].trader;
			var trade = this.storedTrades[username][0].tradeStr;
			var user = this.presUserMap[sender];
			var targetVis = system.createVisible(this.userPresMap[username]);
			system.__debugPrint('Going to send this : ' + this.userPresMap[username] + ' ' +  username+ ' with this message: ' + trade + '\n\n');
			
			
			
			system.__debugPrint('Actually setting up old trades now \n\n');
			
			
			var status = this.checkTransaction(sender, msg.what, msg.to, msg.forTrade);
			if (typeof(status) === 'string') {
				this.storedTrades[username].splice(0,1);
				this.openStoredTrades(username,pres);
				return;
			}
		
			
			
			//Grabbing the index and storing the handler so the handler can cancel itself when finished.
			var index = this.tradeHandlers.length;
			var tradeHandler = std.core.bind(acceptTradeDelayed, this, msg, sender, index, trade, this.userPresMap[username]) << {'resp':'accept':} << targetVis;
			this.tradeHandlers.push(tradeHandler);
		    
			
			//Setting up decline handler.
			var decHandler = std.core.bind(declineTradeDelayed, this, sender, msg, index, this.userPresMap[username]) << {'resp':'decline':} << targetVis;
			//request >> targetVis >> [];
			this.tradeHandlers.push(decHandler);
			//Sending out messages to both parties.
			
			var tradeMsg = new Object();
			tradeMsg.tradeRequest = trade;
			tradeMsg >> targetVis >> [];
			this.tradesOpen[username] = true;
			//msg.makeReply(replyMsg) >> [];
		}
	},
	openTrades: function (username, index, msg, sender) {
		system.__debugPrint('\n\nGot request for old trades\n\n');
		if (username in this.storedTrades && this.storedTrades[username].length > 0)
			this.openStoredTrades(username, sender.toString());
		if (index !== -1)
			this.tradeHandlers[index].clear();
	},
	/*Currently under construction option for connection/synch of multiple banks.  Unfinished. */
	connectBank: function (bank, bankKey, bankKeyConnect) {
        if (bankKey == this.key) {
            var msg = {};
            msg.request = 'bankConnect';
            msg.key = bankKeyConnect;
            msg >> bank >> [std.core.bind(this.setConnection, this)];
        }
	},

	setConnection: function (msg, sender) {
	  this.connected = true;
	  this.connectedBanks.push(sender.toString());
	},

	handleConnection: function (msg, sender) {
        if (msg.key == this.key) {
            this.connected = true;
            this.connectedBanks.push(sender.toString());
            var reply = {};
            reply.msg = 'Connected.';
            msg.makeReply(reply) >> [];
        }
	},
	
	
	/*Responds to requests for an account balance or owned presences.*/

	getRequest: function (msg, sender) {
		var user = this.presUserMap[sender.toString()];
        system.print('Received get request from ' + user + '.\n');
        system.print(this.userPwordMap);
		system.print(this.acctBalanceMap);
        var replyMsg = {};
        if (this.userPresMap[user] == sender.toString()) {
			if(msg.key.type == 'money') {
				replyMsg.value = this.acctBalanceMap[user];
			} else if(msg.key.type == 'presence') {
				if(msg.key.value in this.presOwnMap)
					replyMsg.value = this.presOwnMap[msg.key.value];
				else
					replyMsg.value = '';
			}
        } else {
            replyMsg.error = 'Not logged in.';
        }
        msg.makeReply(replyMsg) >> [];
	}
});
